#include <iostream>
#include <cmath>
using namespace std;
int main(){
    int n,max,min;
    cin>>n;
    int x[n-1],y[n-1];
    int t[n-1];
    for(int a = 0;a<n-1;a++){
        cin>>x[a]>>y[a];
        t[a] = 0;
    }
    if(n==3 || n==4){
        cout<<1;
    }
    else{
        for(int i = 0;i<n-1;i++){
            for(int j = 0;j<n-1;j++){
                if(x[j]==i+1){
                    t[i]+=1;
                }
                if(y[j]==i+1){
                    t[i]+=1;
                }
            }
        }
        for(int j = 0;j<n-1;j++){
            if(max<t[j]){
                max = t[j];
            }
        }
        min = n - 1 -(ceil(float(n)/2)) - (ceil(float(max-2)/2));
        if(min<2){
            cout<<2;
        }
        else{
            cout<<min;
        }
    }
}